/*global define*/
/*jslint browser:true*/
define([
    'testsuite/qunit',
    'jquery',
    'ep/ui/editor',
    'testsuite/qunit-fixture!ckeditor/plugins/epfilterstyle/plugin-test',

    '$ready!'
    ], function (QUnit, $, ep, fixture) {
    'use strict';

    QUnit.module("ckeditor/plugins/epfilterstyle", {
        teardown: fixture.destroy
    });

    QUnit.fixtureVar = fixture;
    QUnit.fixtureVar.init();

    QUnit.asyncTest("basic epfilter plugin tests", function () {

        // check content before cke will be init
        var textArea = ep('#cke_epfilterstyle_test1'),
            textAreaContent = textArea.text();

        QUnit.equal(
            textAreaContent.indexOf("body {") !== -1,
            true,
            'first style body exists'
        );
        QUnit.equal(
            textAreaContent.indexOf("body a {") !== -1,
            true,
            'second style body exists'
        );

        // Initiate CKE.
        textArea.uiEditor();

        // tests after cke init
        setTimeout(function () {

            // Get CKE data.
            var editorInstance = CKEDITOR.instances.cke_epfilterstyle_test1,
                strModifiedData = editorInstance.getData();

            // check that data were filtered
            QUnit.equal(
                strModifiedData.indexOf("body {") !== -1,
                false,
                'first style body is removed'
            );
            QUnit.equal(
                strModifiedData.indexOf("body a {") !== -1,
                false,
                'second style body is removed'
            );

            // check that other data were not removed
            QUnit.equal(
                strModifiedData.indexOf("<span myattr=\"1\" myattr2=\"2\">") !== -1,
                true,
                'span element exists after filter'
            );
            QUnit.equal(
                strModifiedData.indexOf("<p>test</p>") !== -1,
                true,
                'p element exists after filter'
            );
            QUnit.equal(
                strModifiedData.indexOf("<h1>test2</h1>") !== -1,
                true,
                'h1 element exists after filter'
            );

            QUnit.start();
        }, 3000);
    });
});
